#include <PSX/System/IOPorts/timer_io.hpp>
#include <PSX/System/syscalls.hpp>
#include <PSX/Timer/high_res_timer.hpp>

namespace JabyEngine {
    volatile uint16_t HighResTime :: global_counter_10ms = 0;

    namespace Timer {
        static SysCall::InterruptVerifierResult interrupt_verifier() {
            if(Interrupt::is_irq(Interrupt::Timer2)) {
                HighResTime::global_counter_10ms = HighResTime::global_counter_10ms + 1;

                Interrupt::ack_irq(Interrupt::Timer2);
                SysCall::ReturnFromException();
                __builtin_unreachable();
            }
            
            else {
                return SysCall::InterruptVerifierResult::SkipHandler;
            }
        }
        auto irq_callback = SysCall::InterruptCallback::from_single_function(interrupt_verifier);
    }
}